; 
;   MACRO for writing the offset of a label associated with a windows
;   message to the array filled with the default processing address.
;   ALL message labels in the "WndProc" must be in the form,
;       "MSG_"+WM_MESSAGE
;
;   EXAMPLE : MSG_WM_COMMAND::
;   NOTE the "::" which makes it a GLOBAL label
; 

      SetMessage MACRO wm_message
        mOFFSET CATSTR <OFFSET MSG_>,<wm_message>
        mov [eax+wm_message*4], mOFFSET
      ENDM

; 

      DispatchMsg MACRO null
        mov eax, uMsg
        jmp DWORD PTR [wMsgs+eax*4]
      ENDM

; 

;; Retrieves the low word from double word argument
LOWORD	MACRO 	bigword	
	mov	eax,bigword
	and	eax,0FFFFh	;; Set to low word 
	ENDM


;Copy from one memory location to another	
	m2m MACRO M1, M2
		push M2
		pop  M1
	ENDM

; A macro to insert TEXT into the code section for convenient and 
      ; more intuitive coding of functions that use byte data as text.
	;Example
	;szText TheText,"Please Confirm Exit"
        ;invoke MessageBox,hWin,ADDR TheText,ADDR szDisplayName,MB_YESNO

	
	szText MACRO Name, Text:VARARG
		LOCAL lbl
		jmp lbl
			Name db Text,0
		lbl:
	ENDM

 ; ---------------------
    ; literal string MACRO
    ; ---------------------
     literal MACRO quoted_text:VARARG
        LOCAL local_text
        .data
          local_text db quoted_text,0
        .code
        EXITM <local_text>
      ENDM
    ; --------------------------------
    ; string address in INVOKE format
    ; --------------------------------
     SADD MACRO quoted_text:VARARG
        EXITM <ADDR literal(quoted_text)>
      ENDM

	return MACRO arg
        mov eax, arg
        ret
      ENDM
; ------------------------------------------------------------
; Macro for nesting function calls in other invoke statements
; ------------------------------------------------------------

      FUNC MACRO parameters:VARARG
        invoke parameters
        EXITM <eax>
      ENDM
 ;Example
 ;mov hInstance, FUNC(GetModuleHandle,NULL)
      
; -------------------------
    ; Application startup code
    ; -------------------------
     AppStart MACRO
        .code
        start:
        invoke InitMsgArray			;set up dispatcher
        invoke GetModuleHandle, NULL
        mov hInstance, eax

        invoke GetCommandLine
        mov CommandLine, eax

        invoke InitCommonControls

        invoke WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT
        invoke ExitProcess,eax
      ENDM